#include <stdlib.h>
#include <stddef.h>
#include <math.h>

void outverts(verts, hmult)
double *verts, hmult;
{
    int j,k;

    if (OUT==1) {
    for (j=0;j<=3;j++) {
        for (k=0;k<=1;k++) printf("%.3f ",verts[k+j*3]);
        printf("%.3f ",hmult*verts[2+j*3]);
        if (verts[12]==1.0) printf("0.0 0.0 1.0 1.0\n");
        else if (verts[12]==2.0) printf("0.0 1.0 0.0 1.0\n");
        else if (verts[12]==3.0) printf("1.0 0.0 0.0 1.0\n");
        else if (verts[12]==4.0) printf("0.5 0.0 0.5 1.0\n");
        else printf("1.0 1.0 1.0 1.0\n");
    }
    printf("\n");
    fflush(stdout);
    }
}

void addpts1d(x,y,nnx,dg,G)

double *x, *y;
int *nnx, dg, *G;
{
    double hwidth=0.01;
    double hoff=0.2;
    int loc;
    int i,nv;

    /* jittering (y) is in [0,.25] */

    for (i=1;i<=(*nnx);i++) {
        printf("%.3f %.3f %.3f ",x[i-1]-hwidth,
	    -0.5+y[i-1]-hwidth,hoff+y[i-1]);
	if (dg==1) {
        if (G[i-1]==1.0) printf("0.0 0.0 1.0 1.0\n");
        else if (G[i-1]==2.0) printf("0.0 1.0 0.0 1.0\n");
        else if (G[i-1]==3.0) printf("1.0 0.0 0.0 1.0\n");
   	} else printf("0.0 0.0 1.0 1.0\n");

        printf("%.3f %.3f %.3f ",x[i-1]+hwidth,
	    -0.5+y[i-1]-hwidth, hoff+hwidth+y[i-1]);
	if (dg==1) {
        if (G[i-1]==1.0) printf("0.0 0.0 1.0 1.0\n");
        else if (G[i-1]==2.0) printf("0.0 1.0 0.0 1.0\n");
        else if (G[i-1]==3.0) printf("1.0 0.0 0.0 1.0\n");
	} else printf("0.0 0.0 1.0 1.0\n");

        printf("%.3f %.3f %.3f ",x[i-1]+hwidth,
	    -0.5+y[i-1]+hwidth, hoff+y[i-1]);
	if (dg==1) {
        if (G[i-1]==1.0) printf("0.0 0.0 1.0 1.0\n");
        else if (G[i-1]==2.0) printf("0.0 1.0 0.0 1.0\n");
        else if (G[i-1]==3.0) printf("1.0 0.0 0.0 1.0\n");
	} else printf("0.0 0.0 1.0 1.0\n");

        printf("%.3f %.3f %.3f ",x[i-1]-hwidth,
	    -0.5+y[i-1]+hwidth, hoff+y[i-1]);
	if (dg==1) {
        if (G[i-1]==1.0) printf("0.0 0.0 1.0 1.0\n");
        else if (G[i-1]==2.0) printf("0.0 1.0 0.0 1.0\n");
        else if (G[i-1]==3.0) printf("1.0 0.0 0.0 1.0\n");
	} else printf("0.0 0.0 1.0 1.0\n");

        printf("\n");
    } 
}

void addpts2d(x,y,nnx,G,hmult)

double *x, *y, hmult;
int *nnx, *G;
{
    double hwidth=0.015;
    int loc;
    int i,nv;

    for (i=1;i<=(*nnx);i++) {
        printf("%.3f %.3f %.1f ",x[i-1],y[i-1],hmult);
        if (G[i-1]==1.0) printf("0.0 0.0 1.0 1.0\n");
        else if (G[i-1]==2.0) printf("0.0 1.0 0.0 1.0\n");
        else if (G[i-1]==3.0) printf("1.0 0.0 0.0 1.0\n");

        printf("%.3f %.3f %.1f ",x[i-1]-hwidth,y[i-1],hmult);
        if (G[i-1]==1.0) printf("0.0 0.0 1.0 1.0\n");
        else if (G[i-1]==2.0) printf("0.0 1.0 0.0 1.0\n");
        else if (G[i-1]==3.0) printf("1.0 0.0 0.0 1.0\n");

        printf("%.3f %.3f %.1f ",x[i-1]-hwidth,y[i-1]-hwidth,hmult);
        if (G[i-1]==1.0) printf("0.0 0.0 1.0 1.0\n");
        else if (G[i-1]==2.0) printf("0.0 1.0 0.0 1.0\n");
        else if (G[i-1]==3.0) printf("1.0 0.0 0.0 1.0\n");

        printf("%.3f %.3f %.1f ",x[i-1],y[i-1]-hwidth,hmult);
        if (G[i-1]==1.0) printf("0.0 0.0 1.0 1.0\n");
        else if (G[i-1]==2.0) printf("0.0 1.0 0.0 1.0\n");
        else if (G[i-1]==3.0) printf("1.0 0.0 0.0 1.0\n");

        printf("\n");
    }
}

void addwts1d(p,wts,voffset)

double *wts, voffset;
int p;
{
    double hoffset=0.25;
    double hwidth=0.01;
    double hcolor=3.0;
    double boxheight=0.5;
    double grpheight=1.0;
    double binspace,hloc;
    double hweight[100];
    double sum=0.0;
    double verts[13];
    int i,nv;

    verts[0]=verts[9]=-1.0;
    verts[1]=verts[4]=grpheight+hoffset+boxheight+hwidth;
    verts[2]=verts[5]=verts[8]=verts[11]=voffset;
    verts[3]=verts[6]=1.0;
    verts[7]=verts[10]=grpheight+hoffset+2.0*hwidth+boxheight;
    verts[12]=hcolor;
    outverts(verts,2.0);

    verts[0]=verts[9]=-1.0;
    verts[1]=verts[4]=grpheight+hoffset+hwidth;
    verts[2]=verts[5]=verts[8]=verts[11]=voffset;
    verts[3]=verts[6]=-1.0+hwidth;
    verts[7]=verts[10]=grpheight+hoffset+hwidth+boxheight;
    verts[12]=hcolor;
    outverts(verts,2.0);

    verts[0]=verts[9]=-1.0;
    verts[1]=verts[4]=grpheight+hoffset+hwidth;
    verts[2]=verts[5]=verts[8]=verts[11]=voffset;
    verts[3]=verts[6]=-1.0+hwidth;
    verts[7]=verts[10]=grpheight+hoffset+hwidth+boxheight;
    verts[12]=hcolor;
    outverts(verts,2.0);

    verts[0]=verts[9]=1.0-hwidth;
    verts[1]=verts[4]=grpheight+hoffset+hwidth;
    verts[2]=verts[5]=verts[8]=verts[11]=voffset;
    verts[3]=verts[6]=1.0;
    verts[7]=verts[10]=grpheight+hoffset+hwidth+boxheight;
    verts[12]=hcolor;
    outverts(verts,2.0);

    verts[0]=verts[9]=-1.0;
    verts[1]=verts[4]=grpheight+hoffset+0.5*hwidth+0.5*boxheight;
    verts[2]=verts[5]=verts[8]=verts[11]=voffset;
    verts[3]=verts[6]=1.0;
    verts[7]=verts[10]=grpheight+hoffset+2.0*hwidth+0.5*boxheight;
    verts[12]=hcolor;
    outverts(verts,2.0);

    binspace=2.0/(2.0*((double)(p))+1.0);
	
    for (i=1;i<=p;i++) {
   	hloc=-1.0+(2.0*((double)(i))-1.0)*binspace;
    	verts[0]=verts[9]=hloc;
    	verts[1]=verts[4]=grpheight+hoffset+hwidth+0.5*boxheight;
    	verts[2]=verts[5]=voffset;
	verts[8]=verts[11]=voffset-1.0*wts[i-1]*boxheight/4.0;;
    	verts[3]=verts[6]=hloc+binspace;
    	verts[7]=verts[10]=
	    grpheight+hoffset+hwidth+0.5*boxheight+
	    wts[i-1]*boxheight/2.0;
    	if (wts[i-1]>=0.0) verts[12]=1.0;
	else verts[12]=3.0;
	outverts(verts,2.0);
    } 
}


void contour1d(v,x,y,nnx,nnv,dg,k)

double *v, *x, *y;
int *nnx, *nnv, dg, k;
{
    double zspace=0.2;
    double y1, y2;
    double x1, x2;
    double threshold=0.00001;
    double verts[13];
    int i, nv, l;

    for (i=1;i<=(*nnx-1);i++) {
	y1=y[i-1];
	y2=y[i];
	x1=x[i-1];
	x2=x[i];

	if ((y[i-1]+y[i])>threshold) {
	    if (dg==0) verts[12]=1.0;
	    else verts[12]=((double)(k));
	    if (dg==0) verts[2]=verts[5]=verts[8]=verts[11]=0.0;
	    else verts[2]=verts[5]=verts[8]=verts[11]=
	        -1.0 * ((double)(k-1))*zspace;
	    verts[0]=verts[9]=x1;
	    verts[3]=verts[6]=x2;
	    verts[1]=verts[4]=0.0;
	    verts[7]=y2;
	    verts[10]=y1;
	    outverts(verts,2.0);

	    if (dg==0) verts[12]=1.0;
            else verts[12]=((double)(k));
            if (dg==0) { 
	    	verts[2]=verts[5]=0.0;
	    	verts[8]=verts[11]=-1.0*zspace/2.0;;
	    } else {
            	verts[2]=verts[5]=-1.0 * ((double)(k-1))*zspace;
	    	verts[8]=verts[11]=-1.0 * ((double)(k-1))*zspace-zspace/2.0;
	    }
	    verts[0]=verts[9]=x1;
            verts[3]=verts[6]=x2;
            verts[1]=verts[10]=y1;
	    verts[4]=verts[7]=y2;
	    outverts(verts,2.0);
	}
    }
}

int check(z,v,nv)

int nv;
double *z;
double *v;

{
    double min, max;
    double zv[4], bd, ac;
    int i,orient,iv;

    orient=0;
    for (iv=1;iv<=nv;iv++) {
    	for (i=0;i<=3;i++) zv[i]=z[i]-v[iv-1];
    	min=max=zv[0];
    	for (i=1;i<=3;i++) {
	    if (zv[i]<min) min=zv[i];
	    if (zv[i]>max) max=zv[i];
    	}  
        if ((max*min)<=0.0) { 
	    ac=zv[0]*zv[2];
   	    bd=zv[1]*zv[3];
	    if ((bd>0.0)&&(ac>0.0)) {
		if (bd>ac) orient=2;
		else orient=1;
	    }
	}
	if (orient>0) break;
    }
    if (orient==0) {
	if ((fabs(zv[0]-zv[2])>fabs(zv[1]-zv[3]))) orient=2;
	else orient=1;
    }
    return(orient);
}

void vcut(v0,v1,z0,z1,ncuts,cuts)

double v0,v1,z0,z1;
double *cuts;
int *ncuts;

{
    double a;

    (*ncuts)=0;
    if (z0!=z1) { 
	a=(z0-v0)/(z0-z1);
	if ((a>0.0)&&(a<1.0)) {
	    (*ncuts)=1;
	    cuts[0]=a;
	}
	a=(z0-v1)/(z0-z1);
	if ((a>0.0)&&(a<1.0)) {
            (*ncuts)++;
            cuts[(*ncuts)-1]=a;
        }
    }
}

void contour(v,x,y,z,nnx,nny,nnv,dg,k,hmult) 

double *x, *y, *z, *v, hmult;
int *nnx, *nny, *nnv, dg, k;

{

    int ord[16];
    int *vord;
    int iv,ix,iy,i,it,iw,io;
    int vcount,lalp;
    int nv, nx, ny;
    int orient[MAXBINS*MAXBINS];
    double v0, v1, *alp, a0;
    double alphas[3];
    double xxx[4], yyy[4], zzz[4];
    double miz, maz, zziw;
    double xx[4],yy[4],zz[4];
    double x0[5],y0[5],z0[5];
    double x1,y1,z1;
    double cv;
    double verts[13];

    ord[0]=ord[3]=ord[6]=ord[9]=1;  /* 1,2,3,1,3,4,1,3,4,1,2,4,2,3,4,2 */
    ord[1]=ord[10]=ord[12]=ord[15]=2;
    ord[2]=ord[4]=ord[7]=ord[13]=3;
    ord[5]=ord[8]=ord[11]=ord[14]=4;

    alp=alphas;
    vcount=0;
    nv=(*nnv)-1;
    nx=*nnx;
    ny=*nny;

    if (dg==1) nv=1;

    for (i=0;i<((nx-1)*(ny-1));i++) orient[i]=0;

    for (iv=1;iv<=nv;iv++) {
	if (dg==0) {
 	    v0=v[iv-1];
	    v1=v[iv];
            cv=(double) iv;
	} else if (dg==1) {
	    v0=v[0];
            v1=1.1;
            cv=(double) k;
	}
	for (ix=1;ix<=(nx-1);ix++) for (iy=1;iy<=(ny-1);iy++) {
	    xxx[0]=xxx[3]=x[ix-1]; xxx[1]=xxx[2]=x[ix];
	    yyy[0]=yyy[1]=y[iy-1]; yyy[2]=yyy[3]=y[iy];
	    zzz[0]=z[(iy-1)*nx+ix-1];
	    zzz[1]=z[(iy-1)*nx+ix];
	    zzz[2]=z[iy*nx+ix];
	    zzz[3]=z[iy*nx+ix-1];

	    if (orient[(iy-1)*nx+(ix-1)]==0) 
		orient[(iy-1)*nx+(ix-1)]=check(zzz,v,(nv+1));

	    miz=maz=zzz[0];
	    for (i=1;i<=3;i++) {
		if (zzz[i]<miz) miz=zzz[i];
		if (zzz[i]>maz) maz=zzz[i];
	    } 
	    vord=ord;
	    if (orient[(iy-1)*nx+(ix-1)]==2) vord+=8; 
	    for (it=1;it<=2;it++) {
		if (it==2) vord+=4;
		for (i=0;i<=3;i++) {
		    xx[i]=xxx[vord[i]-1];
		    yy[i]=yyy[vord[i]-1];
		    zz[i]=zzz[vord[i]-1];
		}	
		miz=maz=zz[0];
		for (i=1;i<=2;i++) {
		    if (zz[i]>maz) maz=zz[i];
		    if (zz[i]<miz) miz=zz[i];
		}
		if ((maz>v0)&&(miz<=v1)) {
		    if ((miz>v0)&&(maz<=v1)) { /* triangle one color */
			for (i=0;i<=3;i++) {
			    verts[i*3]=xx[i];
                       	    verts[i*3+1]=yy[i];
                       	    verts[i*3+2]=zz[i];
			}
			verts[12]=cv;
			outverts(verts,hmult);
		    } else {
			lalp=0;
			io=0;
			for (iw=1;iw<=3;iw++) {
			    zziw=zz[iw-1];			    
			    if ((zziw==v1)||((zziw>v0)&&(zziw<v1))) {
				io++;
				x0[io-1]=xx[iw-1];
				y0[io-1]=yy[iw-1];
				z0[io-1]=zz[iw-1];
			    }
			    vcut(v0,v1,zz[iw-1],zz[iw],&lalp,alp);
			    if (lalp>0) {
				a0=alp[0];
				if (lalp>1) {
				    if (alp[1]<alp[0]) a0=alp[1];
				}
				io++;
				x0[io-1]=xx[iw-1]+a0*(xx[iw]-xx[iw-1]);
				y0[io-1]=yy[iw-1]+a0*(yy[iw]-yy[iw-1]);
				z0[io-1]=zz[iw-1]+a0*(zz[iw]-zz[iw-1]);
			    }
			    if (lalp>1) {
				a0=alp[0];
                                       if (alp[1]>alp[0]) a0=alp[1];
                                       io++;
                                       x0[io-1]=xx[iw-1]+a0*(xx[iw]-xx[iw-1]);
                                       y0[io-1]=yy[iw-1]+a0*(yy[iw]-yy[iw-1]);
                                       z0[io-1]=zz[iw-1]+a0*(zz[iw]-zz[iw-1]);	
			    }
			} /* end loop from 1 to 3  */
			if (io<5) {
			    for (i=0;i<=(io-1);i++) {
                                verts[i*3]=x0[i];
                                verts[i*3+1]=y0[i];
                                verts[i*3+2]=z0[i];
                            }
			    if (io==3) {
				verts[io*3]=x0[0];
                                verts[io*3+1]=y0[0];
                                verts[io*3+2]=z0[0];
			    }
			    verts[12]=cv;
			    outverts(verts,hmult);
			} else {
			    for (i=0;i<=3;i++) {
                                verts[i*3]=x0[i];
                                verts[i*3+1]=y0[i];
                                verts[i*3+2]=z0[i];
                            }
			    verts[12]=cv;
			    outverts(verts,hmult);
			    for (i=0;i<=3;i++) {
				if (i==0) {
				    x1=x0[0]; y1=y0[0]; z1=z0[0];
				} else if (i==1) {
				    x1=x0[3]; y1=y0[3]; z1=z0[3];
				} else if (i==2) {
				    x1=x0[4]; y1=y0[4]; z1=z0[4];
				} else {
				    x1=x0[0]; y1=y0[0]; z1=z0[0];
				}
			    	verts[i*3]=x1;
                                verts[i*3+1]=y1;
                                verts[i*3+2]=z1;
			    }
			    verts[12]=cv;
			    outverts(verts,hmult);
			}
		    }
		}
	    }
	}
    }
}    
